//+------------------------------------------------------------------+
//|                                            Clusters_analyser.mq4 |
//|                                                         AndreiFX |
//|                                                 AndreiFX@mail.ru |
//+------------------------------------------------------------------+
#property copyright "AndreiFX"
#property link      "AndreiFX@mail.ru"

#property indicator_separate_window
#property indicator_buffers 7
#property indicator_color1 Red
#property indicator_color2 DarkGreen
#property indicator_color3 DarkBlue
#property indicator_color4 Orange
#property indicator_color5 Coral
#property indicator_color6 SeaGreen
#property indicator_color7 MediumSlateBlue

// 
extern bool USD=true;
extern bool EUR=true;
extern bool GBP=true;
extern bool CHF=true;
extern bool JPY=true;
extern bool CAD=true;
extern bool AUD=true;


//---- buffers
double USD[];
double EUR[];
double GBP[];
double CHF[];
double JPY[];
double CAD[];
double AUD[];

// 
double EURGBP,EURCHF,EURJPY,EURCAD,EURAUD,GBPCHF,GBPJPY,GBPCAD,
GBPAUD,CHFJPY,CADCHF,AUDCHF,AUDJPY,
JPYCAD,AUDCAD,
GBPUSD,EURUSD,USDCHF,USDJPY,AUDUSD,USDCAD;
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,USD);
   SetIndexLabel(0,"USD");
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,EUR);
   SetIndexLabel(1,"EUR");
   SetIndexStyle(2,DRAW_LINE);
   SetIndexBuffer(2,GBP);
   SetIndexLabel(2,"GBP");
   SetIndexStyle(3,DRAW_LINE);
   SetIndexBuffer(3,CHF);
   SetIndexLabel(3,"CHF");
   SetIndexStyle(4,DRAW_LINE);
   SetIndexBuffer(4,JPY);
   SetIndexLabel(4,"JPY");
   SetIndexStyle(5,DRAW_LINE);
   SetIndexBuffer(5,CAD);
   SetIndexLabel(5,"CAD");
   SetIndexStyle(6,DRAW_LINE);
   SetIndexBuffer(6,AUD);
   SetIndexLabel(6,"AUD");
   SetIndexStyle(7,DRAW_LINE);
   
   
   SetIndexEmptyValue(0,0);SetIndexEmptyValue(1,0);SetIndexEmptyValue(2,0);SetIndexEmptyValue(3,0);SetIndexEmptyValue(4,0);SetIndexEmptyValue(5,0);SetIndexEmptyValue(6,0);

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
     int counted_bars=IndicatorCounted();
  //----     
     if(counted_bars>0) counted_bars--;
     limit=Bars-counted_bars;
  //----  
     for(int i=limit; i>=0; i--)
       {
//    ///////
if(iClose("GBPUSD",Period(),i)==0||iClose("AUDUSD",Period(),i)==0||iClose("EURUSD",Period(),i)==0||
iClose("USDCHF",Period(),i)==0||iClose("USDJPY",Period(),i)==0) continue;
if(iClose("GBPUSD",Period(),i+1)==0||iClose("AUDUSD",Period(),i+1)==0||iClose("EURUSD",Period(),i+1)==0||
iClose("USDCHF",Period(),i+1)==0||iClose("USDJPY",Period(),i+1)==0) continue;
       /////////////////////////////////     ////////////////////////////////////////////////////
EURGBP=100*(iClose("EURUSD",Period(),i)/iClose("GBPUSD",Period(),i) - iClose("EURUSD",Period(),i+1)/iClose("GBPUSD",Period(),i+1))/(iClose("EURUSD",Period(),i+1)/iClose("GBPUSD",Period(),i+1)) ;
EURCHF=100*(iClose("EURUSD",Period(),i)*iClose("USDCHF",Period(),i) - iClose("EURUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1))/(iClose("EURUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1));
EURJPY=100*(iClose("EURUSD",Period(),i)*iClose("USDJPY",Period(),i) - iClose("EURUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1))/(iClose("EURUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1));
EURCAD=100*(iClose("EURUSD",Period(),i)*iClose("USDCAD",Period(),i) - iClose("EURUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1))/(iClose("EURUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1)); 
EURAUD=100*(iClose("EURUSD",Period(),i)/iClose("AUDUSD",Period(),i) - iClose("EURUSD",Period(),i+1)/iClose("AUDUSD",Period(),i+1))/(iClose("EURUSD",Period(),i+1)/iClose("AUDUSD",Period(),i+1));



GBPCHF=100*(iClose("GBPUSD",Period(),i)*iClose("USDCHF",Period(),i) - iClose("GBPUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1))/(iClose("GBPUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1));
GBPJPY=100*(iClose("GBPUSD",Period(),i)*iClose("USDJPY",Period(),i) - iClose("GBPUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1))/(iClose("GBPUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1));
GBPCAD=100*(iClose("GBPUSD",Period(),i)*iClose("USDCAD",Period(),i) - iClose("GBPUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1))/(iClose("GBPUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1));
GBPAUD=100*(iClose("GBPUSD",Period(),i)/iClose("AUDUSD",Period(),i) - iClose("GBPUSD",Period(),i+1)/iClose("AUDUSD",Period(),i+1))/(iClose("GBPUSD",Period(),i+1)/iClose("AUDUSD",Period(),i+1));

CHFJPY=100*(iClose("USDJPY",Period(),i)/iClose("USDCHF",Period(),i) - iClose("USDJPY",Period(),i+1)/iClose("USDCHF",Period(),i+1))/(iClose("USDJPY",Period(),i+1)/iClose("USDCHF",Period(),i+1));
CADCHF=100*(iClose("USDCHF",Period(),i)/iClose("USDCAD",Period(),i) - iClose("USDCHF",Period(),i+1)/iClose("USDCAD",Period(),i+1))/(iClose("USDCHF",Period(),i+1)/iClose("USDCAD",Period(),i+1));
AUDCHF=100*(iClose("AUDUSD",Period(),i)*iClose("USDCHF",Period(),i) - iClose("AUDUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1))/(iClose("AUDUSD",Period(),i+1)*iClose("USDCHF",Period(),i+1));


AUDJPY=100*(iClose("AUDUSD",Period(),i)*iClose("USDJPY",Period(),i) - iClose("AUDUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1))/(iClose("AUDUSD",Period(),i+1)*iClose("USDJPY",Period(),i+1));




JPYCAD=100*(iClose("USDCAD",Period(),i)/iClose("USDJPY",Period(),i) - iClose("USDCAD",Period(),i+1)/iClose("USDJPY",Period(),i+1))/(iClose("USDCAD",Period(),i+1)/iClose("USDJPY",Period(),i+1));
AUDCAD=100*(iClose("AUDUSD",Period(),i)*iClose("USDCAD",Period(),i) - iClose("AUDUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1))/(iClose("AUDUSD",Period(),i+1)*iClose("USDCAD",Period(),i+1));




GBPUSD=100*(iClose("GBPUSD",Period(),i)-iClose("GBPUSD",Period(),i+1))/iClose("GBPUSD",Period(),i+1);
EURUSD=100*(iClose("EURUSD",Period(),i)-iClose("EURUSD",Period(),i+1))/iClose("EURUSD",Period(),i+1);
USDCHF=100*(iClose("USDCHF",Period(),i)-iClose("USDCHF",Period(),i+1))/iClose("USDCHF",Period(),i+1);
USDJPY=100*(iClose("USDJPY",Period(),i)-iClose("USDJPY",Period(),i+1))/iClose("USDJPY",Period(),i+1);
AUDUSD=100*(iClose("AUDUSD",Period(),i)-iClose("AUDUSD",Period(),i+1))/iClose("AUDUSD",Period(),i+1);

USDCAD=100*(iClose("USDCAD",Period(),i)-iClose("USDCAD",Period(),i+1))/iClose("USDCAD",Period(),i+1);

/////////////////////////////////  ////////////////////////////////////////////////////

////////////////////////////////  ,   ////////////////////////////////////
if(USD)USD[i]=USD[i+1]-GBPUSD+USDCHF+USDJPY+USDCAD-AUDUSD-EURUSD;
if(EUR)EUR[i]=EUR[i+1]+EURGBP+EURCHF+EURJPY+EURCAD+EURAUD+EURUSD;
if(GBP)GBP[i]=GBP[i+1]+GBPCHF+GBPJPY+GBPCAD+GBPAUD+GBPUSD-EURGBP;       
if(CHF)CHF[i]=CHF[i+1]-GBPCHF+CHFJPY-CADCHF-AUDCHF-USDCHF-EURCHF;
if(JPY)JPY[i]=JPY[i+1]-GBPJPY-CHFJPY+JPYCAD-AUDJPY-USDJPY-EURJPY;
if(CAD)CAD[i]=CAD[i+1]-GBPCAD+CADCHF-JPYCAD-AUDCAD-USDCAD-EURCAD;
if(AUD)AUD[i]=AUD[i+1]-GBPAUD+AUDCHF+AUDJPY+AUDCAD+AUDUSD-EURAUD;

       }
//----
   return(0);
  }
//+------------------------------------------------------------------+